﻿using System;
using System.Text.RegularExpressions;
using System.Windows;
using System.Globalization;
using System.Windows.Controls;
using System.Windows.Input;

namespace Prevod_Jednotiek
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            language();
            n1.Opacity = 100;
            n2.Opacity = 0;
            n3.Opacity = 0;
            for (int i = 0; i < 5; i++)
            {
                z.Items.Add(moznosti[i]);
                na.Items.Add(moznosti[i]);
            }
        }

        string zz;
        string nana;
        decimal cislo;

        string[] moznosti = new string[15] {"mm", "cm", "dm", "m", "km", "mg",
                "g", "dkg", "kg", "t", "B", "kB", "MB", "GB", "TB" };

        private void language()
        {
            string[] lng = new string[14] { "cs-CZ", "cs", "sk", "sk-SK", "en", "en-AU",
                "en-BZ", "en-CA", "en-CB", "en-IE", "en-JM", "en-NZ", "en-GB", "en-US", };
            
            CultureInfo ci = CultureInfo.InstalledUICulture;
            string s = ci.Name;
            // s = "en";   // PODSTRĆENIE ENG JAZYKA
            for (int i = 0; i < 4; i++)
            {
                if (s == lng[i])
                {
                    sk.IsChecked = true;
                }
            }
            for (int i = 4; i < 14; i++)
            {
                if (s == lng[i])
                {
                    eng.IsChecked = true;
                }
            }     
        }
        private void b1_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            n1.Opacity = 100;
            n2.Opacity = 0;
            n3.Opacity = 0;

            cisti();

            for (int i = 0; i < 5; i++)
            {
                z.Items.Add(moznosti[i]);
                na.Items.Add(moznosti[i]);
            }
        }
        private void b2_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            n1.Opacity = 0;
            n2.Opacity = 100;
            n3.Opacity = 0;

            cisti();

            for (int i = 5; i < 10; i++)
            {
                z.Items.Add(moznosti[i]);
                na.Items.Add(moznosti[i]);
            }
        }
        private void b3_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            n1.Opacity = 0;
            n2.Opacity = 0;
            n3.Opacity = 100;

            cisti();

            for (int i = 10; i < 15; i++)
            {
                z.Items.Add(moznosti[i]);
                na.Items.Add(moznosti[i]);
            }
        }
        private void NumberValidationTextBox(object sender, TextCompositionEventArgs e)
        {
            Regex regex = new Regex("[^0-9,]+");
            e.Handled = regex.IsMatch(e.Text);
        }
        private void cisti()
        {
            z.SelectedItem = null;
            na.SelectedItem = null;

            for (int i = 0; i < 15; i++)
            {
                z.Items.Remove(moznosti[i]);
                na.Items.Remove(moznosti[i]);
            }

            zadane.Text = "";
            vysledok.Text = "";


        }
        private void englng()
        {
            Title = "Unit Transfer";
            nazov.Text = "Unit Transfer";
            m1.Text = "Lenght";
            m2.Text = "Weight";
            m3.Text = "Data" + Environment.NewLine + "Capacity";
            a1.Text = "Convert from";
            a2.Text = "Convert to";
        }
        private void sklng()
        {
            Title = "Prevod Jednotiek";
            nazov.Text = "Prevod Jednotiek";
            m1.Text = "DĹŽKA";
            m2.Text = "HMOTNOSŤ";
            m3.Text = "DATOVA KAPACITA";
            a1.Text = "Preveď z";
            a2.Text = "Preveď do";
        }
        private void eng_Checked(object sender, RoutedEventArgs e)
        {
            if (sk.IsChecked == true)
            {
                sk.IsChecked = false;
            }

            englng();

        }
        private void sk_Checked(object sender, RoutedEventArgs e)
        {      
            if (eng.IsChecked == true)
            {
                eng.IsChecked = false;
            }

            sklng();

        }
        private void vedeckyzapis()
        {
            /* int celecislo;
            if (int.TryParse(vysledok.Text.ToString(), out celecislo))
            {
                int[] pole = { celecislo };
            }*/

            if (vysledok.Text.Length > 8)
            {
                decimal nacitne = decimal.Parse(vysledok.Text);
                vysledok.Text = (nacitne.ToString("G2", CultureInfo.InvariantCulture));
            }
        }
        private void pocitajdlzka()
        {
            if (nana == zz)
            {
                vysledok.Text = zadane.Text;
            }

            if ((zz == "m") && (nana == "dm") || (zz == "dm") && (nana == "cm") || (zz == "cm") && (nana == "mm"))
            {
                vysledok.Text = (cislo * 10).ToString(); // 10
            }
            else if ((zz == "km") && (nana == "m") || (zz == "m") && (nana == "cm") || (zz == "dm") && (nana == "mm"))
            {
                vysledok.Text = (cislo * 100).ToString(); // 100
            }
            else if ((zz == "m") && (nana == "mm"))
            {
                vysledok.Text = (cislo * 1000).ToString(); // 1000
            }
            else if ((zz == "km") && (nana == "dm"))
            {
                vysledok.Text = (cislo * 10000).ToString(); // 10 000
            }
            else if ((zz == "km") && (nana == "cm"))
            {
                vysledok.Text = (cislo * 100000).ToString(); // 100 000
            }
            else if ((zz == "km") && (nana == "mm"))
            {
                vysledok.Text = (cislo * 1000000).ToString(); // 1 000 000
            }


            else if ((zz == "dm") && (nana == "m") || (zz == "cm") && (nana == "dm") || (zz == "mm") && (nana == "cm"))
            {
                vysledok.Text = (cislo / 10).ToString(); // 10
            }
            else if ((zz == "m") && (nana == "km") || (zz == "mm") && (nana == "dm") || (zz == "cm") && (nana == "m"))
            {
                vysledok.Text = (cislo / 100).ToString(); // 100
            }
            else if ((zz == "mm") && (nana == "m"))
            {
                vysledok.Text = (cislo / 1000).ToString(); // 1 000
            }
            else if ((zz == "dm") && (nana == "km"))
            {
                vysledok.Text = (cislo / 10000).ToString(); // 10 000
            }
            else if ((zz == "cm") && (nana == "km"))
            {
                vysledok.Text = (cislo / 100000).ToString(); // 100 000
            }
            else if ((zz == "mm") && (nana == "km"))
            {
                vysledok.Text = (cislo / 1000000).ToString(); // 1 000 000
            }
        }
        private void pocitajhmotnost()
        {
            if (nana == zz)
            {
                vysledok.Text = zadane.Text;
            }
            else if ((zz == "dkg") && (nana == "g"))
            {
                vysledok.Text = (cislo * 10).ToString(); // 10
            }
            else if ((zz == "kg") && (nana == "dkg"))
            {
                vysledok.Text = (cislo * 100).ToString(); // 100
            }
            else if ((zz == "t") && (nana == "kg") || (zz == "kg") && (nana == "g") || (zz == "g") && (nana == "mg"))
            {
                vysledok.Text = (cislo * 1000).ToString(); // 1 000
            }
            else if ((zz == "dkg") && (nana == "mg"))
            {
                vysledok.Text = (cislo * 10000).ToString(); // 10 000
            }
            else if ((zz == "t") && (nana == "dkg"))
            {
                vysledok.Text = (cislo * 100000).ToString(); // 100 000
            }
            else if ((zz == "t") && (nana == "g") || (zz == "kg") && (nana == "mg"))
            {
                vysledok.Text = (cislo * 1000000).ToString(); // 1 000 000
            }
            else if ((zz == "t") && (nana == "mg"))
            {
                vysledok.Text = (cislo * 1000000000).ToString(); // 1 000 000 000
            }


            else if ((zz == "g") && (nana == "dkg"))
            {
                vysledok.Text = (cislo / 10).ToString(); // 10
            }
            else if ((zz == "dkg") && (nana == "kg"))
            {
                vysledok.Text = (cislo / 100).ToString(); // 100
            }
            else if ((zz == "kg") && (nana == "t") || (zz == "g") && (nana == "kg") || (zz == "mg") && (nana == "g"))
            {
                vysledok.Text = (cislo / 1000).ToString(); // 1 000
            }
            else if ((zz == "mg") && (nana == "dkg"))
            {
                vysledok.Text = (cislo / 10000).ToString(); // 10 000
            }
            else if ((zz == "dkg") && (nana == "t"))
            {
                vysledok.Text = (cislo / 100000).ToString(); // 100 000
            }
            else if ((zz == "g") && (nana == "t") || (zz == "mg") && (nana == "kg"))
            {
                vysledok.Text = (cislo / 1000000).ToString(); // 1 000 000
            }
            else if ((zz == "mg") && (nana == "t"))
            {
                vysledok.Text = (cislo / 1000000000).ToString(); // 1 000 000 000
            }

        }
        private void pocitajdatovukapacitu()
        {
            if ((zz == "TB") && (nana == "GB") || (zz == "GB") && (nana == "MB") || (zz == "MB") && (nana == "kB") || (zz == "kB") && (nana == "B"))
            {
                vysledok.Text = (cislo * 1024).ToString(); // 1024
            }
            else if ((zz == "TB") && (nana == "MB") || (zz == "GB") && (nana == "kB") || (zz == "MB") && (nana == "B"))
            {
                vysledok.Text = (cislo * 1048576).ToString(); // 1 048 576
            }
            else if ((zz == "TB") && (nana == "kB") || (zz == "GB") && (nana == "B"))
            {
                vysledok.Text = (cislo * 1073741824).ToString(); // 1 073 741 824
            }
            else if ((zz == "TB") && (nana == "B"))
            {
                vysledok.Text = (cislo * 1099511627776).ToString(); // 1 099 511 627 776
            }


            else if ((zz == "GB") && (nana == "TB") || (zz == "MB") && (nana == "GB") || (zz == "kB") && (nana == "MB") || (zz == "B") && (nana == "kB"))
            {
                vysledok.Text = (cislo / 1024).ToString(); // 1024
            }
            else if ((zz == "MB") && (nana == "TB") || (zz == "kB") && (nana == "GB") || (zz == "B") && (nana == "MB"))
            {
                vysledok.Text = (cislo / 1048576).ToString(); // 1 048 576
            }
            else if ((zz == "kB") && (nana == "TB") || (zz == "B") && (nana == "GB"))
            {
                vysledok.Text = (cislo / 1073741824).ToString(); // 1 073 741 824
            }
            else if ((zz == "B") && (nana == "TB"))
            {
                vysledok.Text = (cislo / 1099511627776).ToString(); // 1 099 511 627 776
            }
        }
        private void z_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (zadane.Text == "")
            {
                zadane.Text = 0.ToString();
            }

            if (z.SelectedItem != null)
            {
                zz = z.SelectedItem.ToString();
            }

            if (Decimal.TryParse(zadane.Text.ToString(), out cislo))
            {
                pocitajdlzka();
                pocitajhmotnost();
                pocitajdatovukapacitu();

                vedeckyzapis();
            }

            //cislo = decimal.Parse(zadane.Text);
            // pocitajdlzka();
           // pocitajhmotnost();

        }
        private void na_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (zadane.Text == "")
            {
                zadane.Text = 0.ToString();
            }

            if (z.SelectedItem != null)
            {
                nana = na.SelectedItem.ToString();
            }

            if (Decimal.TryParse(zadane.Text.ToString(), out cislo))
            {
                pocitajdlzka();
                pocitajhmotnost();
                pocitajdatovukapacitu();

                vedeckyzapis();
            }


           // cislo = decimal.Parse(zadane.Text);
            //pocitajdlzka();
            //pocitajhmotnost();

        }
        private void zadane_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (zadane.Text != "")
            {
                if ((z.SelectedItem != null) && (na.SelectedItem != null))
                {
                    cislo = decimal.Parse(zadane.Text);
                    pocitajdlzka();
                    pocitajhmotnost();
                    pocitajdatovukapacitu();
                    vedeckyzapis();
                }
            }
        }

        
    }
}
